;
;  Hacker Disassembler Engine
;  Copyright (c) 2006-2007 Veacheslav Patkov.
;  aLL rights reserved.
;

%define C_NONE   00h
%define C_MODRM  01h
%define C_DATA8  02h
%define C_DATA16 04h
%define C_DATA32 08h
%define C_PRE66  10h
%define	C_REL8   20h
%define C_REL32  40h

struc HDE_STRUCT
    .len        resb 1    ; length of command
    .p_rep      resb 1    ; rep & rep(n)z prefix: 0xF2 or 0xF3
    .p_lock     resb 1    ; lock prefix 0xF0
    .p_seg      resb 1    ; segment prefix: 0x2E, 0x36, 0x3E, 0x26, 0x64, 0x65
    .p_66       resb 1    ; prefix 0x66
    .p_67       resb 1    ; prefix 0x67
    .opcode     resb 1    ; opcode
    .opcode2    resb 1    ; second opcode (if first opcode equal 0x0F)
    .modrm      resb 1    ; ModR/M byte
    .modrm_mod  resb 1    ;  - mod byte of ModR/M
    .modrm_reg  resb 1    ;  - reg byte of ModR/M
    .modrm_rm   resb 1    ;  - r/m byte of ModR/M
    .sib        resb 1    ; SIB byte
    .sib_scale  resb 1    ;  - scale byte of SIB
    .sib_index  resb 1    ;  - index byte of SIB
    .sib_base   resb 1    ;  - base byte of SIB
    .imm8       resb 1    ; immediate imm8
    .imm16      resw 1    ; immediate imm16
    .imm32      resd 1    ; immediate imm32
    .disp8      resb 1    ; displacement disp8
    .disp16     resw 1    ; displacement disp16 (if prefix 0x67 exist)
    .disp32     resd 1    ; displacement disp32
    .rel8       resb 1    ; relative address rel8
    .rel16      resw 1    ; relative address rel16 (if prefix 0x66 exist)
    .rel32      resd 1    ; relative address rel32
endstruc

%define delta_table hte_table_ext-hde_table
